package dbdesigner.gmf.editor.edit.parts;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gmf.runtime.notation.View;
import dbdesigner.gmf.editor.providers.DbdesignerSemanticHints;

import org.eclipse.emf.ecore.EAnnotation;

/**
 * @generated
 */
public class DbdesignerEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public static final String EXTERNAL_NODE_LABELS_LAYER = "External Node Labels";

	/**
	 * @generated
	 */
	private String getModelID(View containerView) {
		EAnnotation annotation = containerView.getEAnnotation("ViewIdentifier"); //$NON-NLS-1$
		if (annotation == null) {
			return null;
		}
		return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private int getVisualID(View containerView) {
		EAnnotation annotation = containerView.getEAnnotation("ViewIdentifier"); //$NON-NLS-1$
		if (annotation == null) {
			return -1;
		}
		String visualID = (String) annotation.getDetails().get("visualID"); //$NON-NLS-1$
		if (visualID == null) {
			return -1;
		}
		try {
			return Integer.parseInt(visualID);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			if (!"Dbdesigner".equals(getModelID(view))) {
				return null;
			}

			int viewVisualID = getVisualID(view);
			switch (viewVisualID) {
			case 79:
				return new DatabaseEditPart(view);
			case 1001:
				return new TableEditPart(view);
			case 4001:
				return new Table_nameEditPart(view);
			case 5001:
				return new Table_ColumnCompartmentEditPart(view);
			case 2001:
				return new ColumnEditPart(view);
			case 3001:
				return new FKRelationEditPart(view);
			case 4003:
				if (DbdesignerSemanticHints.FKRelation_3001Labels.FKRELATIONLABEL_4003_LABEL.equals(view.getType())) {
					return new FKRelation_labelEditPart(view);
				} else {
					return new FKRelation_labelTextEditPart(view);
				}
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

}
