package dbdesigner.gmf.editor.edit.policies;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Collection;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.CanonicalConnectionEditPolicy;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.emf.ecore.EObject;
import dbdesigner.Database;
import dbdesigner.FKRelation;

import dbdesigner.gmf.editor.part.DbdesignerVisualIDRegistry;

/**
 * @generated
 */
public class DatabaseCanonicalEditPolicy extends CanonicalConnectionEditPolicy {

	/**
	 * @generated
	 */
	protected List getSemanticChildrenList() {
		Database modelElement = (Database) ((View) getHost().getModel()).getElement();
		List result = new LinkedList();
		EObject nextValue;
		int nodeVID;
		for (Iterator it = modelElement.getTables().iterator(); it.hasNext();) {
			nextValue = (EObject) it.next();
			nodeVID = DbdesignerVisualIDRegistry.INSTANCE.getNodeVisualID((View) getHost().getModel(), nextValue, "");
			if (1001 == nodeVID) {
				result.add(nextValue);
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	protected boolean shouldDeleteView(View view) {
		return view.getElement() != ((View) getHost().getModel()).getElement() && super.shouldDeleteView(view);
	}

	/**
	 * @generated
	 */
	protected List getSemanticConnectionsList() {
		Diagram diagram = (Diagram) getHost().getModel();
		Database modelElement = (Database) diagram.getElement();
		List result = new LinkedList();
		for (Iterator diagramElements = modelElement.eContents().iterator(); diagramElements.hasNext();) {
			EObject nextDiagramElement = (EObject) diagramElements.next();
			for (Iterator childElements = nextDiagramElement.eContents().iterator(); childElements.hasNext();) {
				EObject nextChild = (EObject) childElements.next();
				if (DbdesignerVisualIDRegistry.INSTANCE.getLinkWithClassVisualID(nextChild) != -1) {
					result.add(nextChild);
				}
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	protected EObject getSourceElement(EObject relationship) {
		return relationship.eContainer();
	}

	/**
	 * @generated
	 */
	protected EObject getTargetElement(EObject relationship) {
		int vID = DbdesignerVisualIDRegistry.INSTANCE.getLinkWithClassVisualID(relationship);
		switch (vID) {
		case 3001:
			return ((FKRelation) relationship).getTarget();
		}
		return null;
	}

	/**
	 * For now we are skipping links which was generated based on "GenLinkReferenceOnly" classes
	 * since they do not handle any domain model objects inside, so we can not process them using
	 * CanonicalConnectionEditPolicy class
	 *
	 * @generated
	 */
	protected boolean shouldIncludeConnection(Edge connector, Collection children) {
		return super.shouldIncludeConnection(connector, children) && connector.getElement() != null;
	}
}
