package dbdesigner.gmf.editor.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.emf.commands.core.commands.MSLDestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gmf.runtime.notation.View;
import dbdesigner.Database;
import dbdesigner.DbdesignerPackage;
import dbdesigner.FKRelation;
import dbdesigner.Table;

import dbdesigner.gmf.editor.providers.DbdesignerElementTypes;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.gef.commands.UnexecutableCommand;

import org.eclipse.gmf.runtime.emf.commands.core.commands.MSLCreateRelationshipCommand;

/**
 * @generated
 */
public class TableItemSemanticEditPolicy extends DbdesignerBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getMSLWrapper(new MSLDestroyElementCommand(req) {
			protected EObject getElementToDestroy() {
				View view = (View) getHost().getModel();
				EAnnotation annotation = view.getEAnnotation("Shortcutted"); //$NON-NLS-1$
				if (annotation != null) {
					return view;
				}
				return super.getElementToDestroy();
			}
		});
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		if (DbdesignerElementTypes.FKRelation_3001 == req.getElementType()) {
			return req.getTarget() == null ? getCreateStartOutgoingFKRelation3001Command(req)
					: getCreateCompleteIncomingFKRelation3001Command(req);
		}
		return super.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getCreateStartOutgoingFKRelation3001Command(CreateRelationshipRequest req) {
		return new Command() {
		};
	}

	/**
	 * @generated
	 */
	protected Command getCreateCompleteIncomingFKRelation3001Command(CreateRelationshipRequest req) {
		if (!(req.getSource() instanceof Table)) {
			return UnexecutableCommand.INSTANCE;
		}
		final Database element = (Database) getRelationshipContainer(req.getSource(), DbdesignerPackage.eINSTANCE
				.getDatabase(), req.getElementType());
		if (element == null) {
			return UnexecutableCommand.INSTANCE;
		}
		if (req.getContainmentFeature() == null) {
			req.setContainmentFeature(DbdesignerPackage.eINSTANCE.getDatabase_Fkrelations());
		}
		return getMSLWrapper(new CreateIncomingFKRelation3001Command(req) {

			/**
			 * @generated
			 */
			protected EObject getElementToEdit() {
				return element;
			}
		});
	}

	/**
	 * @generated
	 */
	private static class CreateIncomingFKRelation3001Command extends MSLCreateRelationshipCommand {

		/**
		 * @generated
		 */
		public CreateIncomingFKRelation3001Command(CreateRelationshipRequest req) {
			super(req);
		}

		/**
		 * @generated
		 */
		protected EClass getEClassToEdit() {
			return DbdesignerPackage.eINSTANCE.getDatabase();
		};

		/**
		 * @generated
		 */
		protected void setElementToEdit(EObject element) {
			throw new UnsupportedOperationException();
		}

		/**
		 * @generated
		 */
		protected EObject doDefaultElementCreation() {
			FKRelation newElement = (FKRelation) super.doDefaultElementCreation();
			if (newElement != null) {
				newElement.setTarget((Table) getTarget());
				newElement.setSource((Table) getSource());
			}
			return newElement;
		}
	}
}
