package dbdesigner.gmf.editor.part;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.MarqueeToolEntry;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteDrawer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PanningSelectionToolEntry;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.jface.resource.ImageDescriptor;
import dbdesigner.gmf.editor.providers.DbdesignerElementTypes;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.palette.PaletteSeparator;

import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;

/**
 * @generated
 */
public class DbdesignerPaletteFactory {

	/**
	 * @generated
	 */
	private Diagram diagram;

	/**
	 * @generated
	 */
	private DbdesignerPaletteFactory(Diagram diagram) {
		this.diagram = diagram;
	}

	/**
	 * @generated
	 */
	protected final Diagram getDiagram() {
		return diagram;
	}

	/**
	 * @generated
	 */
	public static PaletteRoot createPalette(Diagram diagram) {
		PaletteRoot paletteRoot = new PaletteRoot();
		DbdesignerPaletteFactory factory = new DbdesignerPaletteFactory(diagram);
		PaletteContainer commonTools = factory.createCommonTools();
		paletteRoot.add(commonTools);
		paletteRoot.setDefaultEntry((ToolEntry) commonTools.getChildren().get(0));
		factory.fillPalette(paletteRoot);
		return paletteRoot;
	}

	/**
	 * @generated
	 */
	public static void fillPalette(PaletteRoot paletteRoot, Diagram diagram) {
		DbdesignerPaletteFactory factory = new DbdesignerPaletteFactory(diagram);
		factory.fillPalette(paletteRoot);
	}

	/**
	 * @generated
	 */
	private void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createDBDesignerGroup());
	}

	/**
	 * @generated
	 */
	private PaletteContainer createCommonTools() {
		PaletteGroup common = new PaletteGroup("Common");
		ToolEntry selectionTool = new PanningSelectionToolEntry();
		common.add(selectionTool);
		common.add(new MarqueeToolEntry());
		return common;
	}

	/**
	 * @generated
	 */
	private PaletteContainer createDBDesignerGroup() {
		PaletteContainer paletteContainer = createContainer("DBDesigner");
		paletteContainer.add(createTableCreationTool());
		paletteContainer.add(createColumnCreationTool());
		paletteContainer.add(new PaletteSeparator());
		paletteContainer.add(createForeignKeyCreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createTableCreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = DbdesignerElementTypes.getImageDescriptor(DbdesignerElementTypes.Table_1001);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(DbdesignerElementTypes.Table_1001);
		return new ToolEntry("Table", "Create a new table", smallImage, largeImage) {
			public Tool createTool() {
				Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
				tool.setProperties(getToolProperties());
				return tool;
			}
		};
	}

	/**
	 * @generated
	 */
	private ToolEntry createColumnCreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = DbdesignerElementTypes.getImageDescriptor(DbdesignerElementTypes.Column_2001);

		largeImage = smallImage;

		final List elementTypes = new ArrayList();
		elementTypes.add(DbdesignerElementTypes.Column_2001);
		return new ToolEntry("Column", "Create a new column", smallImage, largeImage) {
			public Tool createTool() {
				Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
				tool.setProperties(getToolProperties());
				return tool;
			}
		};
	}

	/**
	 * @generated
	 */
	private ToolEntry createForeignKeyCreationTool() {
		ImageDescriptor smallImage;
		ImageDescriptor largeImage;

		smallImage = DbdesignerElementTypes.getImageDescriptor(DbdesignerElementTypes.FKRelation_3001);

		largeImage = smallImage;

		final List relationshipTypes = new ArrayList();
		relationshipTypes.add(DbdesignerElementTypes.FKRelation_3001);
		return new ToolEntry("ForeignKey", "Define foreignkey relation", smallImage, largeImage) {

			public Tool createTool() {
				Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
				tool.setProperties(getToolProperties());
				return tool;
			}
		};
	}

	/**
	 * @generated
	 */
	private PaletteContainer createContainer(String title) {
		return new PaletteDrawer(title);
	}

}
