package dbdesigner.gmf.editor.part;

import dbdesigner.Column;
import dbdesigner.Database;
import dbdesigner.DbdesignerPackage;
import dbdesigner.FKRelation;
import dbdesigner.Table;

import dbdesigner.gmf.editor.providers.DbdesignerSemanticHints;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented 
 * by a domain model object.
 *
 * @generated
 */
public class DbdesignerVisualIDRegistry {

	public static final DbdesignerVisualIDRegistry INSTANCE = new DbdesignerVisualIDRegistry();

	/**
	 * @generated
	 */
	public int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getDiagramVisualID(domainElement, domainElementMetaclass);
	}

	/**
	 * @generated
	 */
	public int getDiagramVisualID(EObject domainElement, EClass domainElementMetaclass) {
		if (DbdesignerPackage.eINSTANCE.getDatabase().equals(domainElementMetaclass)
				&& (domainElement != null ? isDiagramDatabase_79((Database) domainElement) : true)) {
			return 79;
		}
		return getUnrecognizedDiagramID(domainElement);
	}

	/**
	 * @generated
	 */
	public int getNodeVisualID(View containerView, EObject domainElement, String semanticHint) {
		if (domainElement == null) {
			return -1;
		}
		EClass domainElementMetaclass = domainElement.eClass();
		return getNodeVisualID(containerView, domainElement, domainElementMetaclass, semanticHint);
	}

	/**
	 * @generated
	 */
	public int getNodeVisualID(View containerView, EObject domainElement, EClass domainElementMetaclass,
			String semanticHint) {
		String containerModelID = getModelID(containerView);
		if (!"Dbdesigner".equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if ("Dbdesigner".equals(containerModelID)) {
			containerVisualID = getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = 79;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case 79:
			if (DbdesignerPackage.eINSTANCE.getTable().equals(domainElementMetaclass)
					&& (domainElement != null ? isNodeTable_1001((Table) domainElement) : true)) {
				return 1001;
			}
			return getUnrecognizedDiagramChildID(domainElement);
		case 1001:
			if (DbdesignerSemanticHints.Table_1001Labels.TABLENAME_4001_TEXT.equals(semanticHint)) {
				return 4001;
			}
			if (DbdesignerSemanticHints.Table_1001Compartments.COLUMNCOMPARTMENT_5001.equals(semanticHint)) {
				return 5001;
			}
			if (!"".equals(semanticHint)) {
				return getUnrecognizedTable_1001ChildNodeID(semanticHint);
			}
			return getUnrecognizedTable_1001ChildNodeID(domainElement);
		case 5001:
			if (!"".equals(semanticHint)) {
				return getUnrecognizedColumnCompartment_5001ChildNodeID(semanticHint);
			}
			if (DbdesignerPackage.eINSTANCE.getColumn().equals(domainElementMetaclass)
					&& (domainElement != null ? isChildNodeColumn_2001((Column) domainElement) : true)) {
				return 2001;
			}
			return getUnrecognizedColumnCompartment_5001ChildNodeID(domainElement);
		case 2001:
			if (DbdesignerSemanticHints.Column_2001Labels.COLUMNNAME_4002_TEXT.equals(semanticHint)) {
				return 4002;
			}
			if (!"".equals(semanticHint)) {
				return getUnrecognizedColumn_2001ChildNodeID(semanticHint);
			}
			return getUnrecognizedColumn_2001ChildNodeID(domainElement);
		case 3001:
			if (DbdesignerSemanticHints.FKRelation_3001Labels.FKRELATIONLABEL_4003_LABEL.equals(semanticHint)) {
				return 4003;
			}
			return getUnrecognizedFKRelation_3001LinkLabelID(semanticHint);
		case 4003:
			if (DbdesignerSemanticHints.FKRelation_3001Labels.FKRELATIONLABEL_4003_TEXT.equals(semanticHint)) {
				return 4003;
			}
			return getUnrecognizedFKRelation_3001LinkLabelTextID(semanticHint);
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public int getLinkWithClassVisualID(EObject domainElement) {
		EClass domainElementMetaclass = domainElement.eClass();
		return getLinkWithClassVisualID(domainElement, domainElementMetaclass);
	}

	/**
	 * @generated
	 */
	public int getLinkWithClassVisualID(EObject domainElement, EClass domainElementMetaclass) {
		if (DbdesignerPackage.eINSTANCE.getFKRelation().equals(domainElementMetaclass)
				&& (domainElement != null ? isLinkWithClassFKRelation_3001((FKRelation) domainElement) : true)) {
			return 3001;
		} else {
			return getUnrecognizedLinkWithClassID(domainElement);
		}
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private boolean isDiagramDatabase_79(Database element) {
		return true;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedDiagramID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private boolean isNodeTable_1001(Table element) {
		return ElementSelectors.acceptAllMatcher().matches(element);
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private boolean isChildNodeColumn_2001(Column element) {
		return ElementSelectors.acceptAllMatcher().matches(element);
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedDiagramChildID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedTable_1001ChildNodeID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedTable_1001ChildNodeID(String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedColumnCompartment_5001ChildNodeID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedColumnCompartment_5001ChildNodeID(String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedColumn_2001ChildNodeID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedColumn_2001ChildNodeID(String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedFKRelation_3001LinkLabelID(String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedFKRelation_3001LinkLabelTextID(String semanticHint) {
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 *
	 * @generated
	 */
	private int getUnrecognizedLinkWithClassID(EObject domainElement) {
		return -1;
	}

	/**
	 * User can change implementation of this method to check some additional 
	 * conditions here.
	 *
	 * @generated
	 */
	private boolean isLinkWithClassFKRelation_3001(FKRelation element) {
		return ElementSelectors.acceptAllMatcher().matches(element);
	}

	/**
	 * @generated
	 */
	private String getModelID(View containerView) {
		EAnnotation annotation = containerView.getEAnnotation("ViewIdentifier"); //$NON-NLS-1$
		if (annotation == null) {
			return null;
		}
		return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private int getVisualID(View containerView) {
		EAnnotation annotation = containerView.getEAnnotation("ViewIdentifier"); //$NON-NLS-1$
		if (annotation == null) {
			return -1;
		}
		String visualID = (String) annotation.getDetails().get("visualID"); //$NON-NLS-1$
		if (visualID == null) {
			return -1;
		}
		try {
			return Integer.parseInt(visualID);
		} catch (NumberFormatException e) {
			e.printStackTrace();
		}
		return -1;
	}

	/**
	 * @generated
	 */
	private static class ElementSelectors {

		/**
		 * @generated
		 */
		private ElementSelectors() {
		}

		/**
		 * @generated
		 */
		static class AcceptAllMatcher {
			/**
			 * @generated
			 */
			static final AcceptAllMatcher INSTANCE = new AcceptAllMatcher();

			/**
			 * @generated
			 */
			boolean matches(Object element) {
				return true;
			}
		}

		/**
		 * @generated
		 */
		static AcceptAllMatcher acceptAllMatcher() {
			return AcceptAllMatcher.INSTANCE;
		}
	} // end of ElementSelectors
}
