package dbdesigner.gmf.editor.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.ENamedElement;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.IMetamodelType;
import org.eclipse.gmf.runtime.emf.type.core.MetamodelType;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.IEditCommandRequest;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.swt.graphics.Image;
import dbdesigner.DbdesignerFactory;
import dbdesigner.DbdesignerPackage;

import dbdesigner.gmf.editor.part.DbdesignerDiagramEditorPlugin;

import org.eclipse.gmf.runtime.emf.type.core.edithelper.AbstractEditHelper;

/**
 * @generated
 */
public class DbdesignerElementTypes {

	/**
	 * @generated
	 */
	private DbdesignerElementTypes() {
	}

	/**
	 * @generated
	 */
	private static ImageRegistry imageRegistry;

	/**
	 * @generated
	 */
	private static ImageRegistry getImageRegistry() {
		if (imageRegistry == null) {
			imageRegistry = new ImageRegistry();
		}
		return imageRegistry;
	}

	/**
	 * @generated
	 */
	private static String getImageRegistryKey(ENamedElement element) {
		return element.getName();
	}

	/**
	 * @generated
	 */
	private static ImageDescriptor getProvidedImageDescriptor(ENamedElement element) {
		if (element instanceof EStructuralFeature) {
			element = ((EStructuralFeature) element).getEContainingClass();
		}
		if (element instanceof EClass) {
			return DbdesignerDiagramEditorPlugin.getInstance().getItemImageDescriptor(
					DbdesignerFactory.eINSTANCE.create((EClass) element));
		}
		// TODO : support structural features
		return null;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(ENamedElement element) {
		String key = getImageRegistryKey(element);
		ImageDescriptor imageDescriptor = getImageRegistry().getDescriptor(key);
		if (imageDescriptor == null) {
			imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
		}
		return imageDescriptor;
	}

	/**
	 * @generated
	 */
	public static Image getImage(ENamedElement element) {
		String key = getImageRegistryKey(element);
		Image image = getImageRegistry().get(key);
		if (image == null) {
			ImageDescriptor imageDescriptor = getProvidedImageDescriptor(element);
			if (imageDescriptor == null) {
				imageDescriptor = ImageDescriptor.getMissingImageDescriptor();
			}
			getImageRegistry().put(key, imageDescriptor);
			image = getImageRegistry().get(key);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public static ImageDescriptor getImageDescriptor(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImageDescriptor(element);
	}

	/**
	 * @generated
	 */
	public static Image getImage(IAdaptable hint) {
		ENamedElement element = getElement(hint);
		if (element == null) {
			return null;
		}
		return getImage(element);
	}

	/**
	 * Returns 'type' of the ecore object associated with the hint.
	 * 
	 * @generated
	 */
	public static ENamedElement getElement(IAdaptable hint) {
		Object type = hint.getAdapter(IElementType.class);
		if (Database_79 == type) {
			return DbdesignerPackage.eINSTANCE.getDatabase();
		} else if (Table_1001 == type) {
			return DbdesignerPackage.eINSTANCE.getTable();
		} else if (Column_2001 == type) {
			return DbdesignerPackage.eINSTANCE.getColumn();
		} else if (FKRelation_3001 == type) {
			return DbdesignerPackage.eINSTANCE.getFKRelation();
		}
		return null;
	}

	/**
	 * @generated
	 */
	public static final IMetamodelType Database_79 = new MetamodelType("Database_79", null, "Database_79",
			DbdesignerPackage.eINSTANCE.getDatabase(), new NullEditHelper());

	/**
	 * @generated
	 */
	public static final IMetamodelType Table_1001 = new MetamodelType("Table_1001", null, "Table_1001",
			DbdesignerPackage.eINSTANCE.getTable(), new NullEditHelper());

	/**
	 * @generated
	 */
	public static final IMetamodelType Column_2001 = new MetamodelType("Column_2001", null, "Column_2001",
			DbdesignerPackage.eINSTANCE.getColumn(), new NullEditHelper());

	/**
	 * @generated
	 */
	public static final IMetamodelType FKRelation_3001 = new MetamodelType("FKRelation_3001", null, "FKRelation_3001",
			DbdesignerPackage.eINSTANCE.getFKRelation(), new NullEditHelper());

	/**
	 * @generated
	 */
	public static void register() {
		ElementTypeRegistry.getInstance().register(Database_79);
		ElementTypeRegistry.getInstance().register(Table_1001);
		ElementTypeRegistry.getInstance().register(Column_2001);
		ElementTypeRegistry.getInstance().register(FKRelation_3001);
	}

	/**
	 * @generated
	 */
	public static class NullEditHelper extends AbstractEditHelper {

		/**
		 * @generated
		 */
		public ICommand getEditCommand(IEditCommandRequest req) {
			if (!(req instanceof ConfigureRequest)) {
				System.err.println("unserved request " + req);
			}
			return null;
		}
	}
}
