package dbdesigner.gmf.editor.providers;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.diagram.core.providers.AbstractViewProvider;
import org.eclipse.gmf.runtime.notation.View;
import dbdesigner.gmf.editor.part.DbdesignerVisualIDRegistry;

import dbdesigner.gmf.editor.view.factories.ColumnViewFactory;
import dbdesigner.gmf.editor.view.factories.DatabaseViewFactory;
import dbdesigner.gmf.editor.view.factories.FKRelationViewFactory;
import dbdesigner.gmf.editor.view.factories.FKRelation_labelTextViewFactory;
import dbdesigner.gmf.editor.view.factories.FKRelation_labelViewFactory;
import dbdesigner.gmf.editor.view.factories.TableViewFactory;
import dbdesigner.gmf.editor.view.factories.Table_ColumnCompartmentViewFactory;
import dbdesigner.gmf.editor.view.factories.Table_nameViewFactory;

/**
 * @generated
 */
public class DbdesignerViewProvider extends AbstractViewProvider {

	/**
	 * @generated
	 */
	protected Class getDiagramViewClass(IAdaptable semanticAdapter, String diagramKind) {
		EObject semanticElement = getSemanticElement(semanticAdapter);
		if ("Dbdesigner".equals(diagramKind)
				&& DbdesignerVisualIDRegistry.INSTANCE.getDiagramVisualID(semanticElement) != -1) { //$NON-NLS-1$
			return DatabaseViewFactory.class;
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getNodeViewClass(IAdaptable semanticAdapter, View containerView, String semanticHint) {
		if (containerView == null) {
			return null;
		}

		EClass semanticType = getSemanticEClass(semanticAdapter);
		EObject semanticElement = getSemanticElement(semanticAdapter);
		int nodeVID = DbdesignerVisualIDRegistry.INSTANCE.getNodeVisualID(containerView, semanticElement, semanticType,
				semanticHint);

		switch (nodeVID) {
		case 1001:
			return TableViewFactory.class;
		case 4001:
			return Table_nameViewFactory.class;
		case 5001:
			return Table_ColumnCompartmentViewFactory.class;
		case 2001:
			return ColumnViewFactory.class;
		case 4003:
			if (DbdesignerSemanticHints.FKRelation_3001Labels.FKRELATIONLABEL_4003_LABEL.equals(semanticHint)) {
				return FKRelation_labelViewFactory.class;
			} else {
				return FKRelation_labelTextViewFactory.class;
			}
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Class getEdgeViewClass(IAdaptable semanticAdapter, View containerView, String semanticHint) {

		EClass semanticType = getSemanticEClass(semanticAdapter);
		EObject semanticElement = getSemanticElement(semanticAdapter);

		int linkVID = DbdesignerVisualIDRegistry.INSTANCE.getLinkWithClassVisualID(semanticElement, semanticType);

		switch (linkVID) {
		case 3001:
			return FKRelationViewFactory.class;
		}
		return getUnrecognizedConnectorViewClass(semanticAdapter, containerView, semanticHint);
	}

	/**
	 * @generated
	 */
	private Class getUnrecognizedConnectorViewClass(IAdaptable semanticAdapter, View containerView, String semanticHint) {
		// Handle unrecognized child node classes here
		return null;
	}

}
